﻿using System;
using System.Net;
using System.Net.NetworkInformation;
using System.Net.Sockets;

namespace BroadcastAddress {
    class Program {
        static void Main(string[] args) {
            Console.WriteLine(string.Format("{0,16} {1,16} {2,20}", "ADDRESS", "MASK", "BROADCAST"));
            foreach (var netInterface in NetworkInterface.GetAllNetworkInterfaces()) {
                if (netInterface.Supports(NetworkInterfaceComponent.IPv4)) {
                    foreach (var unicast in netInterface.GetIPProperties().UnicastAddresses) {
                        if (unicast.Address.AddressFamily != AddressFamily.InterNetwork) { continue; }
                        var address = unicast.Address;
                        var mask = unicast.IPv4Mask;
                        var addressInt = BitConverter.ToInt32(address.GetAddressBytes(), 0);
                        var maskInt = BitConverter.ToInt32(mask.GetAddressBytes(), 0);
                        var broadcastInt = addressInt | ~maskInt;
                        var broadcastAddress = new IPAddress(BitConverter.GetBytes(broadcastInt));
                        Console.WriteLine(string.Format("{0,16} {1,16} {2,20}", address, mask, broadcastAddress));
                    }
                }
            }
            Console.ReadKey();
        }
    }
}
